1 files changed, 184 insertions, 0 deletions
diff --git a/debian/matrix-synapse.init b/debian/matrix-synapse.init
new file mode 100755
index 0000000000..7a9e8b3296
--- /dev/null
+++ b/debian/matrix-synapse.init
@@ -0,0 +1,184 @@
+#!/bin/sh
+### BEGIN INIT INFO
+# Provides: matrix-synapse
+# Required-Start: $local_fs $network $remote_fs $syslog
+# Required-Stop: $local_fs $network $remote_fs $syslog
+# Default-Start: 2 3 4 5
+# Default-Stop: 0 1 6
+# Short-Description: <Enter a short description of the software>
+# Description: <Enter a long description of the software>
+# <...>
+# <...>
+### END INIT INFO
+
+# Author: Paul "LeoNerd" Evans <paul@matrix.org>
+
+# Do NOT "set -e"
+
+# PATH should only include /usr/* if it runs after the mountnfs.sh script
+PATH=/sbin:/usr/sbin:/bin:/usr/bin
+DESC="matrix-synapse"
+NAME=matrix-synapse
+SCRIPTNAME=/etc/init.d/$NAME
+
+PYTHON="/usr/bin/python"
+CONFIGS="--config-path /etc/matrix-synapse/homeserver.yaml --config-path /etc/matrix-synapse/conf.d/"
+USER="matrix-synapse"
+SHAREDIR=/var/lib/$NAME
+
+# Exit if the package is not installed
+[ -f "/etc/matrix-synapse/homeserver.yaml" ] || exit 0
+
+# Read configuration variable file if it is present
+[ -r /etc/default/$NAME ] && . /etc/default/$NAME
+
+# Load the VERBOSE setting and other rcS variables
+. /lib/init/vars.sh
+
+# Define LSB log_* functions.
+# Depend on lsb-base (>= 3.2-14) to ensure that this file is present
+# and status_of_proc is working.
+. /lib/lsb/init-functions
+
+get_config_key()
+{
+ python -m synapse.config read "$1" $CONFIGS || return 2
+}
+
+#
+# Function that starts the daemon/service
+#
+do_start()
+{
+ # Running --generate-config to create keys if any are absent.
+ # Doesn't matter if not
+ $PYTHON -m "synapse.app.homeserver" $CONFIGS --generate-keys || return 2
+
+ # Return
+ # 0 if daemon has been started
+ # 1 if daemon was already running
+ # 2 if daemon could not be started
+ PIDFILE=`get_config_key "pid_file"`
+ RETVAL=$?
+ if [ "$RETVAL" != 0 ]; then
+ return $RETVAL
+ fi
+ if [ -r "$PIDFILE" ]; then
+ kill -0 `cat $PIDFILE` && return 1
+ fi
+
+ export PYTHONPATH
+
+ # Create the PID file so that synapse can write to it as nonroot
+ touch $PIDFILE
+ chown $USER:nogroup $PIDFILE
+ chown $USER:nogroup $SHAREDIR/media/
+ chown $USER:nogroup $SHAREDIR/uploads/
+
+ start-stop-daemon --start --pidfile $PIDFILE --chuid $USER \
+ --exec $PYTHON -- -m "synapse.app.homeserver" $CONFIGS --daemonize || return 2
+
+ return 0
+}
+
+#
+# Function that stops the daemon/service
+#
+do_stop()
+{
+ # Return
+ # 0 if daemon has been stopped
+ # 1 if daemon was already stopped
+ # 2 if daemon could not be stopped
+ # other if a failure occurred
+ PIDFILE=`get_config_key "pid_file"`
+ RETVAL=$?
+ if [ "$RETVAL" != 0 ]; then
+ return $RETVAL
+ fi
+
+ start-stop-daemon --stop --quiet --retry=TERM/30/KILL/5 --pidfile $PIDFILE --user $USER --exec $PYTHON
+ RETVAL="$?"
+ [ "$RETVAL" = 2 ] && return 2
+
+ # Many daemons don't delete their pidfiles when they exit.
+ rm -f $PIDFILE
+ return "$RETVAL"
+}
+
+#
+# Function that sends a SIGHUP to the daemon/service
+#
+do_reload() {
+ #
+ # If the daemon can reload its configuration without
+ # restarting (for example, when it is sent a SIGHUP),
+ # then implement that here.
+ #
+ return 1
+}
+
+case "$1" in
+ start)
+ [ "$VERBOSE" != no ] && log_daemon_msg "Starting $DESC" "$NAME"
+ do_start
+ case "$?" in
+ 0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
+ 2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
+ esac
+ ;;
+ stop)
+ [ "$VERBOSE" != no ] && log_daemon_msg "Stopping $DESC" "$NAME"
+ do_stop
+ case "$?" in
+ 0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
+ 2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
+ esac
+ ;;
+ status)
+ PIDFILE=`get_config_key "pid_file"`
+ RETVAL=$?
+ if [ "$RETVAL" != 0 ]; then
+ return $RETVAL
+ fi
+ status_of_proc -p "$PIDFILE" "$PYTHON" "$NAME" && exit 0 || exit $?
+ ;;
+ #reload|force-reload)
+ #
+ # If do_reload() is not implemented then leave this commented out
+ # and leave 'force-reload' as an alias for 'restart'.
+ #
+ #log_daemon_msg "Reloading $DESC" "$NAME"
+ #do_reload
+ #log_end_msg $?
+ #;;
+ restart|force-reload)
+ #
+ # If the "reload" option is implemented then remove the
+ # 'force-reload' alias
+ #
+ log_daemon_msg "Restarting $DESC" "$NAME"
+ do_stop
+ case "$?" in
+ 0|1)
+ do_start
+ case "$?" in
+ 0) log_end_msg 0 ;;
+ 1) log_end_msg 1 ;; # Old process is still running
+ *) log_end_msg 1 ;; # Failed to start
+ esac
+ ;;
+ *)
+ # Failed to stop
+ log_end_msg 1
+ ;;
+ esac
+ ;;
+ *)
+ #echo "Usage: $SCRIPTNAME {start|stop|restart|reload|force-reload}" >&2
+ echo "Usage: $SCRIPTNAME {start|stop|status|restart|force-reload}" >&2
+ exit 3
+ ;;
+esac
+
+:
|